<template>
  <table>
    <colgroup>
      <col style="width: 5%; padding-right: 0.25rem;" />
      <col
          v-for="calendar in calendars"
          :key="calendar.id"
          :style="{ width: `${95 / calendars.length}%` }"
      />
    </colgroup>
    <thead>
    <tr>
      <th>&nbsp;</th>
      <th v-for="calendar in calendars" :key="calendar.id" scope="col">
        {{ calendar.attributes.name }}
      </th>
    </tr>
    </thead>
    <tbody>
    <tr v-for="day in weekDays" :key="day.key">
      <th scope="row">{{ day.value }}</th>
      <td v-for="calendar in calendars" :key="calendar.id">
          <span
              v-for="(event, idx) in calendar.attributes.events.get(day.key)"
              :key="idx"
              class="event"
          >
            <span v-if="event.all_day" class="all-day-icon" :style="{height: `${(currentStyles.fontSize * 0.0075)}rem`}" v-html="icon"></span>
            <span v-else
          ><template v-if="showEndTime(event)">
                … {{ formatTime(event.dtend) }}
              </template>
              <template v-else>
                {{ formatTime(event.dtstart) }}
              </template></span
          >&nbsp;{{ event.summary }}</span
          >
      </td>
    </tr>
    </tbody>
  </table>
</template>

<script>
module.exports = {
  name: "calendar-week-overview",
  props: {
    currentSettings: {
      type: Object,
      required: true
    },
    currentStyles: {
      type: Object,
      required: true
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  /* ms * s * min * h => milliseconds in a day */
  millisecondsPerDay: 86400000,
  data: function () {
    return {
      today: new Date()
    };
  },
  asyncComputed: {
    icon: function () {
      return this.fetchAsset("icons", "24-hours.svg");
    }
  },
  computed: {
    calendars: function () {
      return this.records.map(account => {
        const eventsByDateMap = account.attributes.events
            .filter(this.filterPastEvents)
            .filter(this.filterByDate)
            .reduce(this.eventReducer, new Map());

        return {
          ...account,
          attributes: {...account.attributes, events: eventsByDateMap}
        };
      });
    },
    // Builds an array of the next 7 week days to sort calendar entries into.
    weekDays: function () {
      // Using spread operator here because JS … https://itnext.io/heres-why-mapping-a-constructed-array-doesn-t-work-in-javascript-f1195138615a
      return [...new Array(7)].map((_, idx) => {
        // Use reactive data property `today` which triggers a refresh when the current date changes, so that we always show today's week day onwards.
        const timestamp = new Date(
            this.today.valueOf() + idx * this.$options.millisecondsPerDay
        );
        return {
          key: this.timestampToDateString(timestamp),
          value: new Intl.DateTimeFormat(this.language, {
            weekday: "short"
          }).format(timestamp)
        };
      });
    }
  },
  /*
   * Calculate the time until midnight to set up the first refresh, then
   * an interval for 24h to refresh the base Date object this.today.
   */
  mounted: function () {
    const tomorrow = new Date(
        this.today.getFullYear(),
        this.today.getMonth(),
        this.today.getDate() + 1
    );
    const justAfterMidnight = tomorrow - this.today + 2000;
    window.setTimeout(() => {
      this.today = new Date();
      window.setInterval(() => {
        this.today = new Date();
      }, this.$options.millisecondsPerDay);
    }, justAfterMidnight);
  },
  methods: {
    filterPastEvents: function (event) {
      const filter =
          event.all_day || event.several_days || this.currentSettings.showCurrentEvents
              ? event.dtend
              : event.dtstart;
      return new Date(filter) >= Date.now();
    },
    filterByDate: function (event) {
      const eventDate = new Date(event.dtstart);
      const restOfTheDay = new Date().setHours(23, 59, 59, 999);

      // Only include events within the next week
      return (
          eventDate.valueOf() <=
          restOfTheDay + this.$options.millisecondsPerDay * 7
      );
    },
    eventReducer: function (eventsByDateMap, event) {
      const startDate = new Date(event.dtstart);
      event.hasStarted = startDate <= Date.now();
      if (event.several_days) {
        this.mapSeveralDaysEvent(event, eventsByDateMap);
      } else {
        this.addEventOccurrenceToWeekMap(startDate, event, eventsByDateMap);
      }
      return eventsByDateMap;
    },
    // For events that span several days, we need to add the event once for each day. No return value since it mutates the given map.
    /**
     * @param {object} event An event object
     * @param {Map<String,Array>} eventsByDateMap Keys are yyyy-mm-dd strings for each day that has an array of events.
     * @returns void
     */
    mapSeveralDaysEvent: function (event, eventsByDateMap) {
      const startDate = new Date(event.dtstart);
      const endDate = new Date(event.dtend);

      // FIXME: Using midnight would get us consistent event durations, but has a negative offset of one.

      // Avoid miscalculation for late start and early end times, we're only interested in the full-day difference here.
      // startDateMidnight = this.getMidnightForDate(startDate);
      //endDateMidnight = this.getMidnightForDate(endDate);

      const now = Date.now();
      const eventDurationInDays = Math.ceil(
          Math.abs((endDate - startDate) / this.$options.millisecondsPerDay)
      );
      for (let i = 0; i < eventDurationInDays; i++) {
        let copy; // Only copy the event if required.
        if (!event.all_day) {
          copy = {...event};
          // Mark in-between days of a several-day event as all-day for rendering.
          if ((i > 0 || startDate < now) && i < eventDurationInDays - 1) {
            copy.all_day = true;
          }
          if (i === eventDurationInDays - 1) {
            copy.last_of_several = true;
          }
        }
        const occDate = new Date(startDate.getTime() + i * this.$options.millisecondsPerDay);
        this.addEventOccurrenceToWeekMap(
            occDate,
            copy || event,
            eventsByDateMap
        );
      }
    },

    addEventOccurrenceToWeekMap: function (date, event, eventsByDateMap) {
      const dateKey = this.timestampToDateString(date);
      let eventsOnThisDate = eventsByDateMap.get(dateKey) || [];
      eventsOnThisDate.push(event);
      eventsByDateMap.set(dateKey, eventsOnThisDate);
    },
    timestampToDateString: function (timestamp) {
      // Caution: getMonth is zero-indexed, so we add +1 to avoid confusion.
      return `${timestamp.getFullYear()}-${timestamp.getMonth() +
      1}-${timestamp.getDate()}`;
    },
    getMidnightForDate: function (date) {
      return new Date(
          date.getFullYear(),
          date.getMonth(),
          date.getDate(),
          0,
          0,
          0,
          0
      );
    },
    formatTime: function (utcdate) {
      return new Intl.DateTimeFormat(this.language, {
        hour: "2-digit",
        minute: "2-digit"
      }).format(Date.parse(utcdate));
    },
    formatDate: function (date) {
      return new Intl.DateTimeFormat(this.language, {
        month: "2-digit",
        day: "2-digit"
      }).format(Date.parse(date));
    },
    showEndTime: function (event) {
      return (event.hasStarted && !event.several_days) || event.last_of_several;
    }
  }
};
</script>
<style scoped>
table {
  border-spacing: 0.5rem 0.25rem;
  width: 100%;
}

tr {
  vertical-align: center;
  height: 2rem;
}

td {
  border-bottom: 1px solid #666;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

tr:last-child td {
  border-bottom: none;
}

.all-day-icon {
  display: inline-block;
}

.all-day-icon svg {
  height: inherit;
}

.event::after {
  content: ", ";
}

.event:last-of-type::after {
  content: "";
}
</style>
